
@(currentPage: List[Simulation], currentSortBy: String, currentOrder: String, currentFilter: String)

@**********************************
* Helper generating table headers *
**********************************@
@header(key:String, title:String) = {
    <th class="@key.replace(".","_") header @if(currentSortBy == key) @{if(currentOrder == "asc") "headerSortDown" else "headerSortUp"}">
        <a href="@link(key)">@title</a>
    </th>
}

@link(newSortBy:String) = @{
    var sortBy = currentSortBy
    var order = currentOrder

    if(newSortBy != null) {
        sortBy = newSortBy
        if(currentSortBy == newSortBy) {
            if(currentOrder == "asc") {
                order = "desc"
            } else {
                order = "asc"
            }
        } else {
            order = "desc"
        }
    }
    // Generate the link
    routes.SimulationController.list(sortBy, order, currentFilter)
}

@if(currentPage.size == 0 || currentPage == null){
    <h3 class="text-center">No more results to display!</h3>
}else{
    <table id="resultList" class="table table-striped table-bordered">
        <thead>
            <tr>
                @header("name","Simulation Name")
                @header("cloud", "Cloud")
                @header("vm_group_id", "VM Group")
                @header("sim_type", "Type")
                @header("allocation_type", "VM Allocation")
                @header("distribution_type", "VM Distribution")
                @header("num_vms", "# of VMs")
                @header("num_sims", "Status")
                <th>Time(s)</th>
                <th>View Trials</th>
            </tr>
        </thead>

        <tbody id="simList">
        @for(sim <- currentPage) {
            <tr>
                <td><a class="btn btn-link" href="@routes.SimulationController.simSetupDuplicate(sim.getId.toString)"> @sim.getName </a></td>
                <td>@Cloud.findById(sim.getCloud.getId.toString).getName</td>
                <td>@VMGroup.findById(sim.getVmGroup.getId.toString).getName</td>
                @if(sim.getSimType.equals("Normal")){
                    <td>@sim.getSimType</td>
                    <td>@sim.getVmAllocationType</td>
                    <td>@sim.getVmDistributionType</td>
                    <td>@simulation.SimUtils.getNf3.format(sim.getNumVMs)</td>
                    <td>@sim.getNumCompleted / @sim.getNumSims</td>

                    @if(sim.getRunTime > 0){
                        <td>@simulation.SimUtils.getNf2.format(sim.getRunTime)</td>
                        <td>
                            <a class="btn btn-success btn-block" href="@routes.SimulationResultController.getChildResults(sim.getId.toString)">View</a>
                        </td>
                    }else{
                        <td>---</td>
                        <td>
                            <a class="btn btn-warning btn-block" href="@routes.SimulationResultController.getChildResults(sim.getId.toString)">View</a>
                        </td>
                    }
                }else{
                    <td>@sim.getSimType</td>
                    <td>@sim.getVmAllocationType</td>
                    <td>@sim.getVmDistributionType</td>
                    <td>N/A</td>
                    <td>@sim.getNumCompleted / 1</td>

                    @if(sim.getRunTime > 0){
                        <td>@simulation.SimUtils.getNf2.format(sim.getRunTime)</td>
                        <td>
                            <a class="btn btn-success btn-block" href="@routes.SimulationResultController.displayResult(sim.getId().toString, 0)">View</a>
                        </td>
                    }else{
                        <td>---</td>
                        <td>
                            <a class="btn btn-warning btn-block disabled" disabled>View</a>
                        </td>
                    }
                }
            </tr>
        }
        </tbody>
    </table>
}

<script type="text/javascript">
        $(function() {
            @if(currentPage.size == 0 || currentPage == null ){
            $(window).unbind('scroll');     //unbind the scroll event to limit extraneous requests
            }else{
            var simList = $("#simList");
            var filter = '@currentFilter'.replace(/ /g,"+");
            var lastdate =  '@currentPage.last.getDate'.replace(/ /g,"-");

            var nextLink = '/sim/table?d=' + lastdate + '&s=@currentSortBy&o=@currentOrder&f=' + filter;

            $("div#hidLink").append('<a href="'+nextLink+'">' + '</a>');
            }
        });
</script>

<div id="hidLink" style="display:none">
</div>

